= Address Classes

== class TMail::Address

=== Class Methods

: parse( str: String ) -> TMail::Address/TMail::AddressGroup
j
  ʸ str  TMail::Address ޤ TMail::AddressGroup
  ֥Ȥޤstr ᡼륢ɥ쥹Ȥߤʤʤ
  Ȥ㳰 TMail::SyntaxError ȯޤ
e
  parses STR and creates new 'TMail::Address' object.
  If STR did not follow the internet address format,
  'TMail::SyntaxError' exception is raised.
.

: new( locals: Array of String, domains : Array of String )
j
   Address ֥Ȥޤlocalsdomains Ϥ줾
  ɥ쥹ڥå (...@...) Ρκ¦ȱ¦ɥåȤ split 
  ǤΥ᥽åɤѤǤȤˤʤäƤޤ
  Address.parse ȤäƤ
e
  creates new 'TMail::Address' object consist from local part
  LOCALS and domain part DOMAINS.
.

=== Instance Methods

: address_group?
j
     false
e
    returns false.
.

: spec -> String
j
    ɥ쥹ڥåʸ ("....@....")
e
    an address spec ("....@....").
.

: routes -> Array of String
j
    ϩɽʸ'@' ϴޤޤʤ
e
    delivery routes. Strings do not include character "@".
.

: name -> String
: phrase -> String
j
    ¯˸ɥ쥹Ρ̾ʬǥɤƤޤ
e
    short description for this address (e.g. real name).
.

: encoded( eol = "\r\n", encoding = 'j' ) -> String
j
    B 󥳡ɤ줿 RFC2822 ʸɽ֤ޤ
    ɤ eolʸ󥳡ǥ󥰤 encoding Ȥޤ
     encoding  j Ƥޤ
e
    converts this object into MIME-encoded string.
.

: to_s( eol = "\n", encoding = 'e' ) -> String
: decoded( eol = "\n", encoding = 'e' ) -> String
j
    ǥɤ줿 RFC2822 ʸɽ֤ޤ
    ɤ eolʸ󥳡ǥ󥰤 encoding Ȥޤ
e
    converts this object into decoded string.
.

: ==( other ) -> bool
j
    spec ƱȽˤä self  other Ƚꤷޤ
    name  routes ϱƶޤ
e
    judge if self equals to other by inspecting addr-spec string (#spec).
    #name and #routes never affects the return value.
.


== class TMail::AddressGroup

=== Class Methods

: new( name: String, addrs: Array of TMail::Address/TMail::AddressGroup ) -> TMail::AddressGroup
j
   TMail::AddressGroup ֥Ȥޤ
  name ϥ롼̾򼨤ʸaddrs  TMail::Address ޤ
  TMail::AddressGroup ǤʤФޤ
e
  creates new 'TMail::AddressGroup' object.
  NAME is the name of this group, ADDRS is addresses
  which belongs to this group.
.

=== Instance Methods

: address_group?
j
     true
e
    returns true.
.

: name -> String
j
  롼̾
e
  the (human readable) name of this group.
.

: addresses -> Array of TMail::Address/TMail::AddressGroup
j
  TMail::Address ޤ TMail::AddressGroup ֥Ȥ
e
  addresses which belongs to this group.
.

: to_a -> Array of TMail::Address/TMail::AddressGroup
: to_ary -> Array of TMail::Address/TMail::AddressGroup
j
  addresses.dup ƱǤ
e
  equals to 'addresses.dup'.
.

: flatten -> Array of TMail::Address
j
  ƵŪ TMail::AddressGroup ֥Ȥʿó
  TMail::Address ֥Ȥޤ
e
  flatten this group into one level of array of 'TMail::Address'.
.

: add( a: Array of TMail::Address/TMail::AddressGroup )
: push( a: Array of TMail::Address/TMail::AddressGroup )
j
  TMail::Address ޤ TMail::AddressGroup ֥Ȥ
  Υ롼פɲäޤ
e
  adds an address or an group to this group.
.

: delete( addr: Array of TMail::Address/TMail::AddressGroup )
j
  TMail::Address ޤ TMail::AddressGroup ֥Ȥ
  Υ롼פ nil ֤ޤȤȤ
  ɥ쥹롼¸ߤʤ̵뤷 nil ֤ޤ
e
  removes ADDR from this group.
.

: each {|a| .... }
j
  #addresses Ф뷫֤
e
  equals to 'addresses.each {|a| .... }'.
.

: each_address {|a| .... }
j
  #addresses Ф뷫֤ TMail::AddressGroup ֥Ȥ
  ФƤäƺƵŪ˷֤ޤ
e
  equals to 'flatten.each {|a| .... }'
.

: encoded( eol = "\r\n", encoding = 'j' ) -> String
j
  ,B 󥳡ɤ줿 ,RFC2822 ʸɽ֤ޤ
e
  converts this object into MIME-encoded string.
.

: decoded( eol = "\n", encoding = 'e' ) -> String
j
  ǥɤ줿 RFC2822 ʸɽ֤ޤ
e
  converts this object into decoded string.
.

: ==( other )
: eql?( other )
j
  #addresses ƱȽˤäƱƤɤȽǤޤ
  #name ϱƶޤ
e
  judges if self is equal to OTHER, by comparing 'self.addresses' and
  'other.addresses'. ('self.name' is meanless)
.
